/**
 * 总路由入口
 */

import * as asyncHandler from 'express-async-handler';
import * as xywhbsBiz from '../biz/duiwai/xywhbs';
import * as ztbxBiz from '../biz/duiwai/ztbx';
import * as jshxBiz from '../biz/duiwai/jshx';
import * as xshxBiz from '../biz/duiwai/xshx';
import * as xshxgrBiz from '../biz/duiwai/xshxgr';
import * as xsdatcBiz from '../biz/duiwai/xsdatc';
import * as spfxtcBiz from '../biz/duiwai/spfxtc';
//对内
import * as ztbxNBiz from '../biz/duinei/ztbx';
import * as jshxNBiz from '../biz/duinei/jshx';
// import * as njzjshxNBiz from '../biz/duinei/njzjshx';
import * as njzjshxNBiz from '../biz/duinei/njzjshx';
import * as jsgrfzNBiz from '../biz/duinei/jsgrfz';
import * as jyzjshxNBiz from '../biz/duinei/jyzjshx';
import * as xshxNBiz from '../biz/duinei/xshx';
import * as sxjkNBiz from '../biz/duinei/sxjk';
import * as zhsjhdcyqkNBiz from '../biz/duinei/zhsjhdcyqk';
import * as xyspNBiz from '../biz/duinei/xysp';
import * as jssxNBiz from '../biz/duinei/jssx';

import { getHashStr, getTicket } from '../biz/duiwai/getHash';


export function setRouter(httpServer){
    httpServer.post('/gethashstr', asyncHandler(getHashStr));
    httpServer.get('/getticket', asyncHandler(getTicket));

    httpServer.get('/dw/fzlcb', asyncHandler(xywhbsBiz.getData));
    httpServer.get('/dw/ztbx', asyncHandler(ztbxBiz.getData));
    httpServer.get('/dw/jshx', asyncHandler(jshxBiz.getData));
    httpServer.get('/dw/jshx/kxkjx', asyncHandler(jshxBiz.getKxkjx));
    httpServer.get('/dw/jshx/kyqk', asyncHandler(jshxBiz.getKyqk));
    httpServer.get('/dw/jshx/sqxjkt', asyncHandler(jshxBiz.getSqxjkt));
    httpServer.get('/dw/xshx', asyncHandler(xshxBiz.getData));
    httpServer.get('/dw/xshxgr', asyncHandler(xshxgrBiz.getData));
    httpServer.get('/dw/xsdatc', asyncHandler(xsdatcBiz.getData));
    httpServer.get('/dw/spfxtc', asyncHandler(spfxtcBiz.getData));

    httpServer.post('/dw/fzlcb', asyncHandler(xywhbsBiz.getData));
    httpServer.post('/dw/ztbx', asyncHandler(ztbxBiz.getData));
    httpServer.post('/dw/jshx', asyncHandler(jshxBiz.getData));
    httpServer.post('/dw/jshx/kxkjx', asyncHandler(jshxBiz.getKxkjx));
    httpServer.post('/dw/jshx/kyqk', asyncHandler(jshxBiz.getKyqk));
    httpServer.post('/dw/jshx/sqxjkt', asyncHandler(jshxBiz.getSqxjkt));
    httpServer.post('/dw/xshx', asyncHandler(xshxBiz.getData));
    httpServer.post('/dw/xshxgr', asyncHandler(xshxgrBiz.getData));
    httpServer.post('/dw/xsdatc', asyncHandler(xsdatcBiz.getData));
    httpServer.post('/dw/spfxtc', asyncHandler(spfxtcBiz.getData));

    //====================对内=======================
    httpServer.get('/dn/ztbx', asyncHandler(ztbxNBiz.getData));//整体办学
    httpServer.get('/dn/getclass', asyncHandler(ztbxNBiz.getClass));
    httpServer.get('/dn/getkcap', asyncHandler(ztbxNBiz.getKcap));
    httpServer.get('/dn/jshx', asyncHandler(jshxNBiz.getData));//教师画像
    httpServer.get('/dn/jshx/kyqk', asyncHandler(jshxNBiz.getKyqk));
    httpServer.get('/dn/njzjshx', asyncHandler(njzjshxNBiz.getData));
    httpServer.get('/dn/jsgrfz', asyncHandler(jsgrfzNBiz.getData));
    httpServer.get('/dn/jyzjshx', asyncHandler(jyzjshxNBiz.getData));
    httpServer.get('/dn/xshx', asyncHandler(xshxNBiz.getData));
    httpServer.get('/dn/xshxgr', asyncHandler(xshxNBiz.getStudent));
    /**身心健康 */
    httpServer.get('/dn/sxjk/tzjc', asyncHandler(sxjkNBiz.getTzjc));
    httpServer.get('/dn/sxjk/xscqqk', asyncHandler(sxjkNBiz.getXscqqk));
    httpServer.get('/dn/sxjk/tzcsqk', asyncHandler(sxjkNBiz.getTzcsqk));
    /**综合实践活动参与情况 */
    httpServer.get('/dn/zhsjhdcyqk/tddyhd', asyncHandler(zhsjhdcyqkNBiz.getTddyhd));
    httpServer.get('/dn/zhsjhdcyqk/jcsj', asyncHandler(zhsjhdcyqkNBiz.getData));
    httpServer.get('/dn/zhsjhdcyqk/bjtshd', asyncHandler(zhsjhdcyqkNBiz.getBjtshd));
    /**学业水平 */
    httpServer.get('/dn/xysp/gxkcjfx', asyncHandler(xyspNBiz.getGxkcjfx));
    httpServer.get('/dn/xysp/bxqxkbhqs', asyncHandler(xyspNBiz.getBxqxkbhqs));
    httpServer.get('/dn/xysp/jcsj', asyncHandler(xyspNBiz.getData));
    httpServer.get('/dn/xysp/rank', asyncHandler(xyspNBiz.getRank));
    /**筛选弹窗 */
    httpServer.get('/dn/grade', asyncHandler(jssxNBiz.getGrade));
    httpServer.get('/dn/gradesubject/tea', asyncHandler(jssxNBiz.getGradeSubjectTea));

    httpServer.post('/dn/ztbx', asyncHandler(ztbxNBiz.getData));
    httpServer.post('/dn/getclass', asyncHandler(ztbxNBiz.getClass));
    httpServer.post('/dn/getkcap', asyncHandler(ztbxNBiz.getKcap));
    httpServer.post('/dn/jshx', asyncHandler(jshxNBiz.getData));
    httpServer.post('/dn/jshx/kyqk', asyncHandler(jshxNBiz.getKyqk));
    httpServer.post('/dn/njzjshx', asyncHandler(njzjshxNBiz.getData));
    httpServer.post('/dn/jsgrfz', asyncHandler(jsgrfzNBiz.getData));
    httpServer.post('/dn/jyzjshx', asyncHandler(jyzjshxNBiz.getData));
    httpServer.post('/dn/xshx', asyncHandler(xshxNBiz.getData));
    httpServer.post('/dn/xshxgr', asyncHandler(xshxNBiz.getStudent));

    httpServer.post('/dn/sxjk/tzjc', asyncHandler(sxjkNBiz.getTzjc));
    httpServer.post('/dn/sxjk/xscqqk', asyncHandler(sxjkNBiz.getXscqqk));
    httpServer.post('/dn/sxjk/tzcsqk', asyncHandler(sxjkNBiz.getTzcsqk));
    httpServer.post('/dn/zhsjhdcyqk/tddyhd', asyncHandler(zhsjhdcyqkNBiz.getTddyhd));
    httpServer.post('/dn/zhsjhdcyqk/jcsj', asyncHandler(zhsjhdcyqkNBiz.getData));
    httpServer.post('/dn/zhsjhdcyqk/bjtshd', asyncHandler(zhsjhdcyqkNBiz.getBjtshd));
    httpServer.post('/dn/xysp/gxkcjfx', asyncHandler(xyspNBiz.getGxkcjfx));
    httpServer.post('/dn/xysp/bxqxkbhqs', asyncHandler(xyspNBiz.getBxqxkbhqs));
    httpServer.post('/dn/xysp/jcsj', asyncHandler(xyspNBiz.getData));
    httpServer.post('/dn/xysp/rank', asyncHandler(xyspNBiz.getRank));
    httpServer.post('/dn/grade', asyncHandler(jssxNBiz.getGrade));
    httpServer.post('/dn/gradesubject/tea', asyncHandler(jssxNBiz.getGradeSubjectTea));

    httpServer.get('/bmfzr', asyncHandler(zhsjhdcyqkNBiz.getBmfzr));



}

